﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Contracts;
using System.Windows;
using System.ServiceModel;
using System.ComponentModel;

namespace HostApplication
{
    [ServiceBehavior(InstanceContextMode=InstanceContextMode.Single)]
    internal class HostService : IHostInterface, INotifyPropertyChanged
    {
        public void OrderStatusChange(Order order, string newStatus, string oldStatus)
        {
            CurrentMessage = String.Format("Order status changed to {0}", newStatus);
        }

        private string msg;

        public string CurrentMessage {
            get { return msg; }
            set
            {
                msg = value;
                if (PropertyChanged != null)
                    PropertyChanged(this, new PropertyChangedEventArgs("CurrentMessage"));
            }
        }
     
        public event PropertyChangedEventHandler PropertyChanged;
    }
}
