﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Contracts;
using System.ServiceModel;
using System.Threading;
using System.ServiceModel.Description;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;
using System.ServiceModel.Channels;

namespace HostApplication
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Page
    {

        public Window1()
        {
            InitializeComponent();
        }

       
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            //IWorkflowInterface proxy = GetProxy();
            //SetupContextManagerForMultipleInstances(ref proxy);

            App a = (App)Application.Current;

            IWorkflowInterface proxy = new ChannelFactory<IWorkflowInterface>(a.LocalBinding, a.WFAddress).CreateChannel();

            proxy.SubmitOrder(
                new Order
                {
                    CustomerName = "Matt",
                    OrderID = 0,
                    OrderTotal = 250.00
                });

            GetWorkflowInstance(proxy);
        }

        void SetupContextManagerForMultipleInstances(ref IWorkflowInterface proxy)
        {
            IContextManager mgr = ((IClientChannel)proxy).GetProperty<IContextManager>();
            mgr.Enabled = false;
        }

        private void GetWorkflowInstance(IWorkflowInterface proxy)
        {
            IContextManager mgr = ((IClientChannel)proxy).GetProperty<IContextManager>();
            
            string wfID = mgr.GetContext()["instanceId"];
            wfIdText.Text = wfID;
        }

        private IWorkflowInterface GetProxy()
        {
            App a = (App)Application.Current;
            
            IWorkflowInterface proxy = new ChannelFactory<IWorkflowInterface>(a.LocalBinding, a.WFAddress).CreateChannel();
            //SetupContextManagerForMultipleInstances(ref proxy);
            return proxy;
        }

            

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            IWorkflowInterface proxy = GetProxy();
            //SetupContextManagerForMultipleInstances(ref proxy);

            SetWorkflowIDOnProxy(proxy);

            proxy.UpdateOrder(
                new Order
                {
                    CustomerName = "Matt",
                    OrderID = 2,
                    OrderTotal = 250.00,
                    OrderStatus="Updated"
                });
        }

        private void SetWorkflowIDOnProxy(IWorkflowInterface proxy)
        {
            IContextManager mgr = ((IClientChannel)proxy).GetProperty<IContextManager>();
            mgr.SetContext(new Dictionary<string, string>{
                {"instanceId", wfIdText.Text}
            });
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            HostService host =  ((App)Application.Current).appHost.SingletonInstance as HostService;
            if (host != null)
                this.DataContext = host;
        }
    }
}
