﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Workflow.ComponentModel;
using System.Windows.Forms;

namespace WorkflowsAndActivities
{
	public class WriteLine : Activity
	{
        public static DependencyProperty OutputTextProperty = DependencyProperty.Register("OutputText", typeof(string), typeof(WriteLine));

        [System.ComponentModel.DescriptionAttribute("The text to be written")]
        [System.ComponentModel.CategoryAttribute("Console")]
        [System.ComponentModel.BrowsableAttribute(true)]
        [System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)]
        public string OutputText
        {
            get
            {
                return ((string)(base.GetValue(WriteLine.OutputTextProperty)));
            }
            set
            {
                base.SetValue(WriteLine.OutputTextProperty, value);
            }
        }

        public static DependencyProperty ForegroundColorProperty = DependencyProperty.Register("ForegroundColor", typeof(ConsoleColor), typeof(WriteLine));

        [System.ComponentModel.DescriptionAttribute("Foreground Color for the text")]
        [System.ComponentModel.CategoryAttribute("Console")]
        [System.ComponentModel.BrowsableAttribute(true)]
        [System.ComponentModel.DesignerSerializationVisibilityAttribute(System.ComponentModel.DesignerSerializationVisibility.Visible)]
        public ConsoleColor ForegroundColor
        {
            get
            {
                return ((ConsoleColor)(base.GetValue(WriteLine.ForegroundColorProperty)));
            }
            set
            {
                base.SetValue(WriteLine.ForegroundColorProperty, value);
            }
        }

        protected override ActivityExecutionStatus Execute(ActivityExecutionContext executionContext)
        {
            if (ForegroundColor != null)
                Console.ForegroundColor = ForegroundColor;

            //Console.WriteLine(OutputText);

            Console.ResetColor();

            MessageBox.Show(OutputText);
            return ActivityExecutionStatus.Closed;

        }
	}
}
